Index: uspace/lib/ui/private/entry.h
===================================================================
--- uspace/lib/ui/private/entry.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/private/entry.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,4 +40,5 @@
 #include <gfx/coord.h>
 #include <gfx/text.h>
+#include <stdbool.h>
 
 /** Actual structure of text entry.
@@ -48,13 +49,57 @@
 	/** Base control object */
 	struct ui_control *control;
-	/** UI resource */
-	struct ui_resource *res;
+	/** UI window */
+	struct ui_window *window;
 	/** Entry rectangle */
 	gfx_rect_t rect;
 	/** Horizontal alignment */
 	gfx_halign_t halign;
+	/** Text entry is read-only */
+	bool read_only;
 	/** Text */
 	char *text;
+	/** Current scroll position (in pixels) */
+	gfx_coord_t scroll_pos;
+	/** Cursor position in the text (offset in bytes) */
+	unsigned pos;
+	/** Selection start position in text (offset in bytes) */
+	unsigned sel_start;
+	/** Pointer is currently inside */
+	bool pointer_inside;
+	/** Entry is activated */
+	bool active;
+	/** Button is held down */
+	bool held;
+	/** Left shift is held down */
+	bool lshift_held;
+	/** Right shift is held down */
+	bool rshift_held;
 };
+
+/** Text entry geometry.
+ *
+ * Computed geometry of text entry elements.
+ */
+typedef struct {
+	/** Interior rectangle */
+	gfx_rect_t interior_rect;
+	/** Text rectangle */
+	gfx_rect_t text_rect;
+	/** Text anchor position */
+	gfx_coord2_t text_pos;
+	/** Text anchor X coordinate */
+	gfx_coord_t anchor_x;
+} ui_entry_geom_t;
+
+extern errno_t ui_entry_insert_str(ui_entry_t *, const char *);
+extern ui_evclaim_t ui_entry_key_press_ctrl(ui_entry_t *, kbd_event_t *);
+extern ui_evclaim_t ui_entry_key_press_shift(ui_entry_t *, kbd_event_t *);
+extern ui_evclaim_t ui_entry_key_press_unmod(ui_entry_t *, kbd_event_t *);
+extern void ui_entry_get_geom(ui_entry_t *, ui_entry_geom_t *);
+extern size_t ui_entry_find_pos(ui_entry_t *, gfx_coord2_t *);
+extern void ui_entry_delete_sel(ui_entry_t *);
+extern void ui_entry_activate(ui_entry_t *);
+extern void ui_entry_deactivate(ui_entry_t *);
+extern void ui_entry_scroll_update(ui_entry_t *, bool);
 
 #endif
Index: uspace/lib/ui/private/filedialog.h
===================================================================
--- uspace/lib/ui/private/filedialog.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/private/filedialog.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file File dialog structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_FILEDIALOG_H
+#define _UI_PRIVATE_FILEDIALOG_H
+
+/** Actual structure of file dialog.
+ *
+ * This is private to libui.
+ */
+struct ui_file_dialog {
+	/** Dialog window */
+	struct ui_window *window;
+	/** File name entry */
+	struct ui_entry *ename;
+	/** OK button */
+	struct ui_pbutton *bok;
+	/** Cancel button */
+	struct ui_pbutton *bcancel;
+	/** File dialog callbacks */
+	struct ui_file_dialog_cb *cb;
+	/** Callback argument */
+	void *arg;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/menu.h
===================================================================
--- uspace/lib/ui/private/menu.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/private/menu.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,88 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_MENU_H
+#define _UI_PRIVATE_MENU_H
+
+#include <adt/list.h>
+#include <gfx/coord.h>
+#include <stdbool.h>
+#include <types/ui/menu.h>
+#include <types/ui/resource.h>
+
+/** Actual structure of menu.
+ *
+ * This is private to libui.
+ */
+struct ui_menu {
+	/** Containing menu bar */
+	struct ui_menu_bar *mbar;
+	/** Link to @c bar->menus */
+	link_t lmenus;
+	/** Caption */
+	char *caption;
+	/** Popup window or @c NULL if menu is not currently open */
+	struct ui_popup *popup;
+	/** Selected menu entry or @c NULL */
+	struct ui_menu_entry *selected;
+	/** Maximum caption width */
+	gfx_coord_t max_caption_w;
+	/** Maximum shortcut width */
+	gfx_coord_t max_shortcut_w;
+	/** Total entry height */
+	gfx_coord_t total_h;
+	/** Menu entries (ui_menu_entry_t) */
+	list_t entries;
+};
+
+/** Menu geometry.
+ *
+ * Computed rectangles of menu elements.
+ */
+typedef struct {
+	/** Outer rectangle */
+	gfx_rect_t outer_rect;
+	/** Entries rectangle */
+	gfx_rect_t entries_rect;
+} ui_menu_geom_t;
+
+extern void ui_menu_get_geom(ui_menu_t *, gfx_coord2_t *, ui_menu_geom_t *);
+extern ui_resource_t *ui_menu_get_res(ui_menu_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/menubar.h
===================================================================
--- uspace/lib/ui/private/menubar.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/private/menubar.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu bar structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_MENUBAR_H
+#define _UI_PRIVATE_MENUBAR_H
+
+#include <adt/list.h>
+#include <gfx/coord.h>
+#include <types/ui/menu.h>
+#include <types/ui/menubar.h>
+
+/** Actual structure of menu bar.
+ *
+ * This is private to libui.
+ */
+struct ui_menu_bar {
+	/** Base control object */
+	struct ui_control *control;
+	/** UI */
+	struct ui *ui;
+	/** UI window containing menu bar */
+	struct ui_window *window;
+	/** Menu bar rectangle */
+	gfx_rect_t rect;
+	/** Selected menu or @c NULL */
+	struct ui_menu *selected;
+	/** List of menus (ui_menu_t) */
+	list_t menus;
+};
+
+extern void ui_menu_bar_select(ui_menu_bar_t *, gfx_rect_t *, ui_menu_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/menuentry.h
===================================================================
--- uspace/lib/ui/private/menuentry.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/private/menuentry.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,89 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu entry structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_MENUENTRY_H
+#define _UI_PRIVATE_MENUENTRY_H
+
+#include <adt/list.h>
+#include <gfx/coord.h>
+#include <types/ui/menuentry.h>
+
+/** Actual structure of menu entry.
+ *
+ * This is private to libui.
+ */
+struct ui_menu_entry {
+	/** Containing menu */
+	struct ui_menu *menu;
+	/** Link to @c menu->entries */
+	link_t lentries;
+	/** Callbacks */
+	ui_menu_entry_cb_t cb;
+	/** This entry is a separator entry */
+	bool separator;
+	/** Menu entry is currently held down */
+	bool held;
+	/** Pointer is currently inside */
+	bool inside;
+	/** Callback argument */
+	void *arg;
+	/** Caption */
+	char *caption;
+	/** Shortcut key(s) */
+	char *shortcut;
+};
+
+/** Menu entry geometry.
+ *
+ * Computed positions of menu entry elements.
+ */
+typedef struct {
+	/** Outer rectangle */
+	gfx_rect_t outer_rect;
+	/** Caption position */
+	gfx_coord2_t caption_pos;
+	/** Shortcut position */
+	gfx_coord2_t shortcut_pos;
+} ui_menu_entry_geom_t;
+
+extern void ui_menu_entry_get_geom(ui_menu_entry_t *, gfx_coord2_t *,
+    ui_menu_entry_geom_t *);
+extern void ui_menu_entry_cb(ui_menu_entry_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/msgdialog.h
===================================================================
--- uspace/lib/ui/private/msgdialog.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/private/msgdialog.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Message dialog structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_MSGDIALOG_H
+#define _UI_PRIVATE_MSGDIALOG_H
+
+/** Actual structure of message dialog.
+ *
+ * This is private to libui.
+ */
+struct ui_msg_dialog {
+	/** Dialog window */
+	struct ui_window *window;
+	/** OK button */
+	struct ui_pbutton *bok;
+	/** Message dialog callbacks */
+	struct ui_msg_dialog_cb *cb;
+	/** Callback argument */
+	void *arg;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/popup.h
===================================================================
--- uspace/lib/ui/private/popup.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/private/popup.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,65 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Popup structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_POPUP_H
+#define _UI_PRIVATE_POPUP_H
+
+#include <gfx/coord.h>
+#include <types/ui/window.h>
+
+/** Actual structure of popup window.
+ *
+ * This is private to libui.
+ */
+struct ui_popup {
+	/** Containing user interface */
+	struct ui *ui;
+	/** Callbacks */
+	struct ui_popup_cb *cb;
+	/** Callback argument */
+	void *arg;
+	/** Parent window */
+	struct ui_window *parent;
+	/** Window */
+	struct ui_window *window;
+	/** Placement rectangle */
+	gfx_rect_t place;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/rbutton.h
===================================================================
--- uspace/lib/ui/private/rbutton.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/private/rbutton.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,82 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Radio button structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_RBUTTON_H
+#define _UI_PRIVATE_RBUTTON_H
+
+#include <gfx/coord.h>
+#include <stdbool.h>
+
+/** Actual structure of radio button group.
+ *
+ * This is private to libui.
+ */
+struct ui_rbutton_group {
+	/** UI resource */
+	struct ui_resource *res;
+	/** Callbacks */
+	struct ui_rbutton_group_cb *cb;
+	/** Callback argument */
+	void *arg;
+	/** Selected button */
+	struct ui_rbutton *selected;
+};
+
+/** Actual structure of radio button.
+ *
+ * This is private to libui.
+ */
+struct ui_rbutton {
+	/** Base control object */
+	struct ui_control *control;
+	/** Containing radio button group */
+	struct ui_rbutton_group *group;
+	/** Callback argument */
+	void *arg;
+	/** Radio button rectangle */
+	gfx_rect_t rect;
+	/** Caption */
+	const char *caption;
+	/** Radio button is currently held down */
+	bool held;
+	/** Pointer is currently inside */
+	bool inside;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/resource.h
===================================================================
--- uspace/lib/ui/private/resource.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/private/resource.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -42,4 +42,6 @@
 #include <gfx/font.h>
 #include <gfx/typeface.h>
+#include <stdbool.h>
+#include <types/ui/resource.h>
 
 /** Actual structure of UI resources.
@@ -54,4 +56,6 @@
 	/** Font */
 	gfx_font_t *font;
+	/** Text mode */
+	bool textmode;
 
 	/** Button frame color */
@@ -70,4 +74,8 @@
 	/** Window text color */
 	gfx_color_t *wnd_text_color;
+	/** Window selected text color */
+	gfx_color_t *wnd_sel_text_color;
+	/** Window selected text background color */
+	gfx_color_t *wnd_sel_text_bg_color;
 	/** Window frame hightlight color */
 	gfx_color_t *wnd_frame_hi_color;
@@ -92,4 +100,11 @@
 	/** Entry (text entry, checkbox, raido button) background color */
 	gfx_color_t *entry_bg_color;
+	/** Entry (text entry, checkbox, raido button) active background color */
+	gfx_color_t *entry_act_bg_color;
+
+	/** Expose callback or @c NULL */
+	ui_expose_cb_t expose_cb;
+	/** Expose callback argument */
+	void *expose_arg;
 };
 
Index: uspace/lib/ui/private/slider.h
===================================================================
--- uspace/lib/ui/private/slider.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/private/slider.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,71 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Slider structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_SLIDER_H
+#define _UI_PRIVATE_SLIDER_H
+
+#include <gfx/coord.h>
+#include <stdbool.h>
+
+/** Actual structure of slider.
+ *
+ * This is private to libui.
+ */
+struct ui_slider {
+	/** Base control object */
+	struct ui_control *control;
+	/** UI resource */
+	struct ui_resource *res;
+	/** Callbacks */
+	struct ui_slider_cb *cb;
+	/** Callback argument */
+	void *arg;
+	/** Slider rectangle */
+	gfx_rect_t rect;
+	/** Slider is currently held down */
+	bool held;
+	/** Position where button was pressed */
+	gfx_coord2_t press_pos;
+	/** Last slider position */
+	gfx_coord_t last_pos;
+	/** Slider position */
+	gfx_coord_t pos;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/ui.h
===================================================================
--- uspace/lib/ui/private/ui.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/private/ui.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,5 +38,7 @@
 #define _UI_PRIVATE_UI_H
 
+#include <adt/list.h>
 #include <display.h>
+#include <io/console.h>
 #include <stdbool.h>
 
@@ -46,4 +48,8 @@
  */
 struct ui {
+	/** Console */
+	console_ctrl_t *console;
+	/** Console GC */
+	struct console_gc *cgc;
 	/** Display */
 	display_t *display;
@@ -52,4 +58,6 @@
 	/** @c true if terminating */
 	bool quit;
+	/** Windows (in stacking order, ui_window_t) */
+	list_t windows;
 };
 
Index: uspace/lib/ui/private/window.h
===================================================================
--- uspace/lib/ui/private/window.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/private/window.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,5 +38,7 @@
 #define _UI_PRIVATE_WINDOW_H
 
+#include <adt/list.h>
 #include <errno.h>
+#include <congfx/console.h>
 #include <display.h>
 #include <gfx/context.h>
@@ -44,4 +46,6 @@
 #include <io/pos_event.h>
 #include <memgfx/memgc.h>
+#include <types/ui/cursor.h>
+#include <types/ui/window.h>
 
 /** Actual structure of window.
@@ -52,4 +56,6 @@
 	/** Containing user interface */
 	struct ui *ui;
+	/** Link to @c ui->windows */
+	link_t lwindows;
 	/** Callbacks */
 	struct ui_window_cb *cb;
@@ -60,4 +66,10 @@
 	/** Window GC */
 	gfx_context_t *gc;
+	/** Window bitmap (if client-side rendering) */
+	gfx_bitmap_t *bmp;
+	/** Window memory GC (if client-side rendering) */
+	mem_gc_t *mgc;
+	/** Real window GC (if client-side rendering) */
+	gfx_context_t *realgc;
 	/** Window rectangle */
 	gfx_rect_t rect;
@@ -68,4 +80,6 @@
 	/** Application area GC */
 	gfx_context_t *app_gc;
+	/** Dirty rectangle */
+	gfx_rect_t dirty_rect;
 	/** UI resource. Ideally this would be in ui_t. */
 	struct ui_resource *res;
@@ -78,4 +92,5 @@
 };
 
+extern display_stock_cursor_t wnd_dcursor_from_cursor(ui_stock_cursor_t);
 extern void ui_window_send_close(ui_window_t *);
 extern void ui_window_send_focus(ui_window_t *);
